
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.io.*;

public class mahjong extends JFrame implements ActionListener {
    
    int[] iPaiData = {
11,12,13,14,15,16,17,18,19,            // Y
21,22,23,24,25,26,27,28,29,            // sY
31,32,33,34,35,36,37,38,39,            // \EY
41,42,43,44,                           // 쐼k
51,52,53,                              // 

11,12,13,14,15,16,17,18,19,            // Y
21,22,23,24,25,26,27,28,29,            // sY
31,32,33,34,35,36,37,38,39,            // \EY
41,42,43,44,                           // 쐼k
51,52,53,                              // 

11,12,13,14,15,16,17,18,19,            // Y
21,22,23,24,25,26,27,28,29,            // sY
31,32,33,34,35,36,37,38,39,            // \EY
41,42,43,44,                           // 쐼k
51,52,53,                              // 

11,12,13,14,15,16,17,18,19,            // Y
21,22,23,24,25,26,27,28,29,            // sY
31,32,33,34,35,36,37,38,39,            // \EY
41,42,43,44,                           // 쐼k
51,52,53                              // 
    };

    boolean bIsStart = false;

    Vector vMotoPai;
    Vector vHaiPai;
    Vector vMyHaiPai;
    Vector vComHaiPai;
    Vector vMySuteHai;
    Vector vComSuteHai;
    int    iDora;
    int    iUraDora;
    Vector vMyPai;
    Vector vComPai;
    int    iComTumo;

    boolean bIsComIkasama = false; // 
    boolean bIsComOpenPai = false; // 
    Vector vComAllHaiPai;          // bnlvlpFS̃nCpC
    Vector vComAllHaiPaiNoDup;     // bnlvlpFS̏dȂnCpC
    Vector vComAgariPai;           // bnlvlpFnC
    Vector vComMachiPaiForAgari;   // bnlvlpFnCɂȂ邽߂̑҂nC
    Vector vComSutePaiForAgari;    // bnlvlpFnCɂȂ邽߂̎̂ănC
    boolean bIsComRandom = false;  // bnlvlpF肪܂ĂȂŃ_ɂĂ邩ǂ

    JPanel topPanel;
    JPanel bottomPanel;
    JPanel myHaiPaiPanel1;
    JPanel myHaiPaiPanel2;
    JPanel myHaiPaiPanel3;
    JPanel comHaiPaiPanel1;
    JPanel comHaiPaiPanel2;
    JPanel comHaiPaiPanel3;
    JCheckBox checkboxIsComIkasama;
    JCheckBox checkboxIsComOpenPai;
    JButton   btnStart;
    JButton   btnRon;
    
    public void haipai() {
        vMotoPai = new Vector();
        for( int i=0; i < iPaiData.length; i++ ) {
            vMotoPai.add( new Integer( iPaiData[i] ) );
        }
        Collections.shuffle( vMotoPai );
        Integer itDora = (Integer) vMotoPai.get(0);
        iDora = itDora.intValue();
        Integer itUraDora = (Integer) vMotoPai.get(1);
        iUraDora = itUraDora.intValue();
        vMyPai = new Vector();
        for( int i=0; i < 13; i++ ) {
            vMyPai.add( vMotoPai.get( i+2 ) );
        }
        vComPai = new Vector();
        for( int i=0; i < 13; i++ ) {
            vComPai.add( vMotoPai.get( i+2+13 ) );
        }
        vHaiPai = new Vector();
        for( int i=(2+13+13); true; i++ ) {
            if( i >= vMotoPai.size() ) break;
            vHaiPai.add( vMotoPai.get(i) );
        }
        vMyHaiPai = new Vector();
        vComHaiPai = new Vector();
        for( int i=0; i < vHaiPai.size(); i+=2 ) {
            vMyHaiPai.add( vHaiPai.get(i) );
            vComHaiPai.add( vHaiPai.get( i+1 ) );
        }
        Collections.sort( vMyPai );
        Collections.sort( vComPai );
    }
    public boolean paiCheck( Vector v ) {
        int iAnkoCnt = 0;
        int[] iPai = new int[13];
        for( int i=0; i < 13; i++ ) {
            Integer it = (Integer) v.get(i);
            iPai[i] = it.intValue();
        }
        for( int i=0; i < (13-2); i++ ) {
            if( iPai[i] == iPai[i+1] && iPai[i] == iPai[i+2] ) {
                iAnkoCnt++;
                i+=2;
            }
        }
        if( iAnkoCnt >= 3 ) {
            return( true );
        }
        boolean bIsAllMan = true;
        for( int i=0; i < (13-3); i++ ) {
            if( iPai[i] >= 11 && iPai[i] <= 19 ) {
                continue;
            }
            bIsAllMan = false;
            break;
        }
        if( bIsAllMan ) {
            return( true );
        }
        boolean bIsAllPin = true;
        for( int i=0; i < (13-3); i++ ) {
            if( iPai[i] >= 21 && iPai[i] <= 29 ) {
                continue;
            }
            bIsAllPin = false;
            break;
        }
        if( bIsAllPin ) {
            return( true );
        }
        boolean bIsAllSou = true;
        for( int i=0; i < (13-3); i++ ) {
            if( iPai[i] >= 31 && iPai[i] <= 39 ) {
                continue;
            }
            bIsAllSou = false;
            break;
        }
        if( bIsAllSou ) {
            return( true );
        }
        boolean bIsAllJi = true;
        for( int i=0; i < (13-3); i++ ) {
            if( iPai[i] >= 41 ) {
                continue;
            }
            bIsAllJi = false;
            break;
        }
        if( bIsAllJi ) {
            return( true );
        }
        return( false );
    }
    public String toPaiString( int iPai ) {
        String sOut = "";
        if( iPai >= 11 && iPai <= 19 ) {    // }Y
            int i = ( iPai % 10 );
            sOut += Integer.toString( i );
            sOut += "";
        }
        if( iPai >= 21 && iPai <= 29 ) {    // sY
            int i = ( iPai % 10 );
            sOut += Integer.toString( i );
            sOut += "";
        }
        if( iPai >= 31 && iPai <= 39 ) {    // \EY
            int i = ( iPai % 10 );
            sOut += Integer.toString( i );
            sOut += "h";
        }
        if( iPai == 41 ) sOut = "";
        if( iPai == 42 ) sOut = "";
        if( iPai == 43 ) sOut = "";
        if( iPai == 44 ) sOut = "k";
        if( iPai == 51 ) sOut = "";
        if( iPai == 52 ) sOut = "";
        if( iPai == 53 ) sOut = "";
        return( sOut );
    }
    public void ikasamaHaipai() {
        boolean bOK = false;
        for( int i=0; i < 900000; i++ ) {
            haipai();
            if( paiCheck( vMyPai ) ) {
                bOK = true;
                break;
            }
        }
//System.out.println("vMyHaiPai size=" + vMyHaiPai.size());
        if( bOK ) {
        } else {
            JOptionPane.showMessageDialog(null, "nCpCł܂łBēxNĂ");
            //System.out.println("nCpCł܂łBēxNĂ");
            System.exit(1);
        }
    }
    public void addComponentsToPane(final Container pane) {

        topPanel = new JPanel();
        topPanel.setLayout(new GridLayout(1,15));
        if( bIsComOpenPai ) {
            for( int i=0; i < 13; i++ ) {
                Integer it = (Integer) vComPai.get(i);
                String s = toPaiString( it.intValue() );
                //JButton btn = new JButton( s );
                JButton btn = createPaiButton( it.intValue(), true /*isBigButton*/ );
                topPanel.add( btn );
            }
            topPanel.add( new JLabel() );
            topPanel.add( new JButton());
        } else {
            for( int i=0; i < 13; i++ ) {
                JButton btn = createPaiButton( 0, true /*isBigButton*/ );
                topPanel.add( btn );
            }
            topPanel.add( new JLabel() );
            topPanel.add( new JButton());
        }
        bottomPanel = new JPanel();
        bottomPanel.setLayout(new GridLayout(1,15));
        for( int i=0; i < 13; i++ ) {
            Integer it = (Integer) vMyPai.get(i);
            String s = toPaiString( it.intValue() );
            //JButton btn = new JButton( s );
            JButton btn = createPaiButton( it.intValue(), true /*isBigButton*/ );
            btn.setActionCommand(Integer.toString(i));
            btn.addActionListener(this);
            bottomPanel.add( btn );
        }
        bottomPanel.add( new JLabel() );
        JButton btnTumo = new JButton();
        btnTumo.setActionCommand("13");
        btnTumo.addActionListener(this);
        bottomPanel.add( btnTumo );

        myHaiPaiPanel1 = new JPanel();
        myHaiPaiPanel1.setLayout(new GridLayout(1,20));
        myHaiPaiPanel2 = new JPanel();
        myHaiPaiPanel2.setLayout(new GridLayout(1,20));
        myHaiPaiPanel3 = new JPanel();
        myHaiPaiPanel3.setLayout(new GridLayout(1,20));
        for( int i=0; i < 20; i++ ) {
            JLabel lbl1 = new JLabel();
            JLabel lbl2 = new JLabel();
            JLabel lbl3 = new JLabel();
            myHaiPaiPanel1.add( lbl1 );
            myHaiPaiPanel2.add( lbl2 );
            myHaiPaiPanel3.add( lbl3 );
        }
        comHaiPaiPanel1 = new JPanel();
        comHaiPaiPanel1.setLayout(new GridLayout(1,20));
        comHaiPaiPanel2 = new JPanel();
        comHaiPaiPanel2.setLayout(new GridLayout(1,20));
        comHaiPaiPanel3 = new JPanel();
        comHaiPaiPanel3.setLayout(new GridLayout(1,20));
        for( int i=0; i < 20; i++ ) {
            JLabel lbl1 = new JLabel();
            JLabel lbl2 = new JLabel();
            JLabel lbl3 = new JLabel();
            comHaiPaiPanel1.add( lbl1 );
            comHaiPaiPanel2.add( lbl2 );
            comHaiPaiPanel3.add( lbl3 );
        }
        JPanel centerPanel = new JPanel();
        centerPanel.setLayout(new GridLayout(1,3));
        btnStart = new JButton("Jn");
        btnStart.setActionCommand("start");
        btnStart.addActionListener(this);
        centerPanel.add(btnStart);
        JPanel centerPanel2 = new JPanel();
        centerPanel2.setLayout(new GridLayout(2,1));
        checkboxIsComIkasama = new JCheckBox("COMvl");
        checkboxIsComIkasama.setActionCommand("comikasama");
        checkboxIsComIkasama.addActionListener(this);
        centerPanel2.add(checkboxIsComIkasama);
        checkboxIsComOpenPai = new JCheckBox("COMI[v");
        checkboxIsComOpenPai.setActionCommand("comopen");
        checkboxIsComOpenPai.addActionListener(this);
        centerPanel2.add(checkboxIsComOpenPai);
        centerPanel.add(centerPanel2);
        btnRon = new JButton("");
        btnRon.setEnabled( false );
        btnRon.setActionCommand("ron");
        btnRon.addActionListener(this);
        centerPanel.add(btnRon);

        // Cpl
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout(new GridLayout(11,1));
        
        //Set up components preferred size
        mainPanel.setPreferredSize(new Dimension( 515, 700 ));
        
        //Cplɕi𑫂
        mainPanel.add(topPanel);
        mainPanel.add(new JLabel("-------"));
        mainPanel.add(comHaiPaiPanel3);
        mainPanel.add(comHaiPaiPanel2);
        mainPanel.add(comHaiPaiPanel1);
        mainPanel.add(centerPanel);
        mainPanel.add(myHaiPaiPanel1);
        mainPanel.add(myHaiPaiPanel2);
        mainPanel.add(myHaiPaiPanel3);
        mainPanel.add(new JLabel("-------"));
        mainPanel.add(bottomPanel);
        
        pane.add(mainPanel, BorderLayout.CENTER);
    }
    public void actionPerformed(ActionEvent e) {
        String sAction = e.getActionCommand();
        //JButton b = (JButton) e.getSource();
        //String sText = b.getText();
        if( sAction != null && sAction.equals("start") ) {
            bIsStart = true;
            vMySuteHai = new Vector();
            vComSuteHai = new Vector();
            myTumo();
            myPaiRedraw();
            if( bIsComIkasama ) {
                boolean bComOK = comInit();
                if( bComOK ) {
                    bIsComRandom = false;
                } else {
                    JOptionPane.showMessageDialog(null, "COM̂茈߂ł܂łA_Ɏ̂ănC܂");
                    bIsComRandom = true;
                }
            } else {
                bIsComRandom = true;
            }
            btnStart.setEnabled( false );
            checkboxIsComIkasama.setEnabled( false );
            return;
        }
        if( sAction != null && sAction.equals("comikasama") ) {
            if( checkboxIsComIkasama.isSelected() ) {
                bIsComIkasama = true;
System.out.println("debug: com̃CJT}܂");
            } else {
                bIsComIkasama = false;
System.out.println("debug: com̃CJT}܂");
            }
            return;
        }
        if( sAction != null && sAction.equals("comopen") ) {
            if( checkboxIsComOpenPai.isSelected() ) {
                bIsComOpenPai = true;
System.out.println("debug: comopen܂");
            } else {
                bIsComOpenPai = false;
System.out.println("debug: comopen܂");
            }
            comPaiRedraw();
            return;
        }
        if( sAction != null && sAction.equals("ron") ) {
            Collections.sort( vMyPai );
            String s = checkYakuman();
            JOptionPane.showMessageDialog(null, "ł " + s);
            bIsStart = false;
            return;
        }
        if( sAction != null ) {
            if( bIsStart ) {
            } else {
                return;
            }
            // ̂ănC̈ʒu
            int iSute = -1;
            for( int i=0; i < 14; i++ ) {
                String s = Integer.toString(i);
                if( sAction.equals(s) ) {
                    iSute = i;
                    break;
                }
            }
            if( iSute < 0 ) {
                JOptionPane.showMessageDialog(null, "System error: push button ُł");
                System.exit(1);
            }
            // ̂
            myPaiRemove( iSute );
            mySutePaiRedraw();
//System.out.println("̂Č: vMyPai=" + vMyPai);
            // COM
            comTumo();
            if( bIsComRandom ) {
                int iRnd = (int)(Math.random() * 13); // 0-12
                comPaiRemove( iRnd );
            } else {
                // ĉ҂nCɂ邩
                // A
                // ȂAĉ̂Ă
                int ii = iComTumo;
                boolean bExist = isHaiExist( vComMachiPaiForAgari, ii );
                if( bExist ) {
                    if( vComMachiPaiForAgari.size() == 1 ) {
                        // 
                        comPaiRedraw();
                        // thread ŁAbnl̂o
                        //JOptionPane.showMessageDialog(null, "COM̂łB^s");
                        comAgariDisp rc = new comAgariDisp();
                        Thread t1 = new Thread(rc);
                        t1.start();

                        bIsStart = false;
                        return;
                    } else {
                        // ̂ănC̒̂Ă
                        Integer it = (Integer) vComSutePaiForAgari.get(0);
                        comPaiRemoveByPai( it.intValue() );
                        // ̂ănC̍ŏ
                        Vector vTmp2 = new Vector();
                        for( int i=1; i < vComSutePaiForAgari.size(); i++ ) {
                            vTmp2.add( vComSutePaiForAgari.get(i) );
                        }
                        vComSutePaiForAgari = new Vector();
                        for( int i=0; i < vTmp2.size(); i++ ) {
                            vComSutePaiForAgari.add( vTmp2.get(i) );
                        }
                        // ҂nC
                        Vector vTmp = removePai( vComMachiPaiForAgari, new Integer(ii) );
                        vComMachiPaiForAgari = new Vector();
                        for( int i=0; i < vTmp.size(); i++ ) {
                            vComMachiPaiForAgari.add( vTmp.get(i) );
                        }
                    }
                } else {
                    comPaiRemove( 13 );
                }
            }
            comSutePaiRedraw();
            Collections.sort( vComPai );
            comPaiRedraw();
            // COM
            Collections.sort( vMyPai );
            myTumo();
            myPaiRedraw();
            String sYaku = checkYakuman();
            if( sYaku.length() > 0 ) {
                btnRon.setEnabled( true );
            }
            return;
        }
    }
    class comAgariDisp implements Runnable {
        public void run() {
            JOptionPane.showMessageDialog(null, "COM̂łB^s");
        }
    }
    public void myPaiRedraw() {
        if( bIsStart ) {
        } else {
            return;
        }
        bottomPanel.removeAll();
        for( int i=0; i < 13; i++ ) {
            Integer it = (Integer) vMyPai.get(i);
            String s = toPaiString( it.intValue() );
            //JButton btn = new JButton( s );
            JButton btn = createPaiButton( it.intValue(), true /*isBigButton*/ );
            btn.setActionCommand(Integer.toString(i));
            btn.addActionListener(this);
            bottomPanel.add( btn );
        }
        bottomPanel.add( new JLabel() );
        Integer it2 = (Integer) vMyPai.get(13);
        JButton btnTumo = createPaiButton( it2.intValue(), true /*isBigButton*/ );
        btnTumo.setActionCommand("13");
        btnTumo.addActionListener(this);
        bottomPanel.add( btnTumo );
        bottomPanel.revalidate();
        bottomPanel.repaint();
    }
    public void comPaiRedraw() {
        //if( bIsStart ) {
        //} else {
        //    return;
        //}
        topPanel.removeAll();
        if( bIsComOpenPai ) {
            for( int i=0; i < 13; i++ ) {
                Integer it = (Integer) vComPai.get(i);
                String s = toPaiString( it.intValue() );
                //JButton btn = new JButton( s );
                JButton btn = createPaiButton( it.intValue(), true /*isBigButton*/ );
                //btn.setActionCommand(Integer.toString(i));
                //btn.addActionListener(this);
                topPanel.add( btn );
            }
            topPanel.add( new JLabel() );
            if( vComPai.size() > 13 ) {
                Integer it2 = (Integer) vComPai.get(13);
                JButton btnTumo = createPaiButton( it2.intValue(), true /*isBigButton*/ );
                //btnTumo.setActionCommand("13");
                //btnTumo.addActionListener(this);
                topPanel.add( btnTumo );
            } else {
                topPanel.add( new JButton() );
            }
        } else {
            // E\
            for( int i=0; i < 13; i++ ) {
                JButton btn = createPaiButton( 0, true /*isBigButton*/ );
                topPanel.add( btn );
            }
            topPanel.add( new JLabel() );
            topPanel.add( new JButton() );
        }
        topPanel.revalidate();
        topPanel.repaint();
    }
    public void mySutePaiRedraw() {
        myHaiPaiPanel1.removeAll();
        myHaiPaiPanel2.removeAll();
        myHaiPaiPanel3.removeAll();
        if( !vMySuteHai.isEmpty() ) {
            for( int i=0; i < 20; i++ ) {
                if( i <= (vMySuteHai.size()-1) ) {
                    Integer it = (Integer) vMySuteHai.get(i);
                    JButton btn = createPaiButton( it.intValue(), false /*isBigButton*/ );
                    myHaiPaiPanel1.add( btn );
                } else {
                    JLabel lbl = new JLabel();
                    myHaiPaiPanel1.add( lbl );
                }
            }
        } else {
            for( int i=0; i < 20; i++ ) {
                JLabel lbl = new JLabel();
                myHaiPaiPanel1.add( lbl );
            }
        }
        if( vMySuteHai.size() > 20 ) {
            for( int i=20; i < 40; i++ ) {
                if( i <= (vMySuteHai.size()-1) ) {
                    Integer it = (Integer) vMySuteHai.get(i);
                    JButton btn = createPaiButton( it.intValue(), false /*isBigButton*/ );
                    myHaiPaiPanel2.add( btn );
                } else {
                    JLabel lbl = new JLabel();
                    myHaiPaiPanel2.add( lbl );
                }
            }
        } else {
            for( int i=20; i < 40; i++ ) {
                JLabel lbl = new JLabel();
                myHaiPaiPanel2.add( lbl );
            }
        }
        if( vMySuteHai.size() > 40 ) {
            for( int i=40; i < 60; i++ ) {
                if( i <= (vMySuteHai.size()-1) ) {
                    Integer it = (Integer) vMySuteHai.get(i);
                    JButton btn = createPaiButton( it.intValue(), false /*isBigButton*/ );
                    myHaiPaiPanel3.add( btn );
                } else {
                    JLabel lbl = new JLabel();
                    myHaiPaiPanel3.add( lbl );
                }
            }
        } else {
            for( int i=40; i < 60; i++ ) {
                JLabel lbl = new JLabel();
                myHaiPaiPanel3.add( lbl );
            }
        }
        myHaiPaiPanel1.revalidate();
        myHaiPaiPanel2.revalidate();
        myHaiPaiPanel3.revalidate();
        myHaiPaiPanel1.repaint();
        myHaiPaiPanel2.repaint();
        myHaiPaiPanel3.repaint();
    }
    public void comSutePaiRedraw() {
        comHaiPaiPanel1.removeAll();
        comHaiPaiPanel2.removeAll();
        comHaiPaiPanel3.removeAll();
        if( !vComSuteHai.isEmpty() ) {
            for( int i=0; i < 20; i++ ) {
                if( i <= (vComSuteHai.size()-1) ) {
                    Integer it = (Integer) vComSuteHai.get(i);
                    JButton btn = createPaiButton( it.intValue(), false /*isBigButton*/ );
                    comHaiPaiPanel1.add( btn );
                } else {
                    JLabel lbl = new JLabel();
                    comHaiPaiPanel1.add( lbl );
                }
            }
        } else {
            for( int i=0; i < 20; i++ ) {
                JLabel lbl = new JLabel();
                comHaiPaiPanel1.add( lbl );
            }
        }
        if( vComSuteHai.size() > 20 ) {
            for( int i=20; i < 40; i++ ) {
                if( i <= (vComSuteHai.size()-1) ) {
                    Integer it = (Integer) vComSuteHai.get(i);
                    JButton btn = createPaiButton( it.intValue(), false /*isBigButton*/ );
                    comHaiPaiPanel2.add( btn );
                } else {
                    JLabel lbl = new JLabel();
                    comHaiPaiPanel2.add( lbl );
                }
            }
        } else {
            for( int i=20; i < 40; i++ ) {
                JLabel lbl = new JLabel();
                comHaiPaiPanel2.add( lbl );
            }
        }
        if( vComSuteHai.size() > 40 ) {
            for( int i=40; i < 60; i++ ) {
                if( i <= (vComSuteHai.size()-1) ) {
                    Integer it = (Integer) vComSuteHai.get(i);
                    JButton btn = createPaiButton( it.intValue(), false /*isBigButton*/ );
                    comHaiPaiPanel3.add( btn );
                } else {
                    JLabel lbl = new JLabel();
                    comHaiPaiPanel3.add( lbl );
                }
            }
        } else {
            for( int i=40; i < 60; i++ ) {
                JLabel lbl = new JLabel();
                comHaiPaiPanel3.add( lbl );
            }
        }
        comHaiPaiPanel1.revalidate();
        comHaiPaiPanel2.revalidate();
        comHaiPaiPanel3.revalidate();
        comHaiPaiPanel1.repaint();
        comHaiPaiPanel2.repaint();
        comHaiPaiPanel3.repaint();
    }
    public void myTumo() {
        // vMyHaiPai PƂA vMyPai 
        if( vMyHaiPai.isEmpty() ) {
            JOptionPane.showMessageDialog(null, "Ił");
            bIsStart = false;
            return;
        }
        Integer it = (Integer) vMyHaiPai.get(0);
        vMyPai.add( it );
        // vMyHaiPai 炷
        Vector vTmp = new Vector();
        for( int i=1; i < vMyHaiPai.size(); i++ ) {
            vTmp.add( vMyHaiPai.get(i) );
        }
        vMyHaiPai = new Vector();
        for( int i=0; i < vTmp.size(); i++ ) {
            vMyHaiPai.add( vTmp.get(i) );
        }
    }
    public void comTumo() {
        // vComHaiPai PƂA vComPai 
        if( vComHaiPai.isEmpty() ) {
            JOptionPane.showMessageDialog(null, "COMIł");
            bIsStart = false;
            return;
        }
        Integer it = (Integer) vComHaiPai.get(0);
        vComPai.add( it );
        iComTumo = it.intValue();
        // vComHaiPai 炷
        Vector vTmp = new Vector();
        for( int i=1; i < vComHaiPai.size(); i++ ) {
            vTmp.add( vComHaiPai.get(i) );
        }
        vComHaiPai = new Vector();
        for( int i=0; i < vTmp.size(); i++ ) {
            vComHaiPai.add( vTmp.get(i) );
        }
    }
    public void myPaiRemove( int iIdx ) {
        Vector vTmp = new Vector();
        for( int i=0; i < vMyPai.size(); i++ ) {
            if( i == iIdx ) {
                vMySuteHai.add( vMyPai.get(i) );
            } else {
                vTmp.add( vMyPai.get(i) );
            }
        }
        vMyPai = new Vector();
        for( int i=0; i < vTmp.size(); i++ ) {
            vMyPai.add( vTmp.get(i) );
        }
    }
    public void comPaiRemove( int iIdx ) {
        Vector vTmp = new Vector();
        for( int i=0; i < vComPai.size(); i++ ) {
            if( i == iIdx ) {
                vComSuteHai.add( vComPai.get(i) );
            } else {
                vTmp.add( vComPai.get(i) );
            }
        }
        vComPai = new Vector();
        for( int i=0; i < vTmp.size(); i++ ) {
            vComPai.add( vTmp.get(i) );
        }
    }
    public void comPaiRemoveByPai( int ii ) {
        // vComPai T
        int iIdx = -1;
        for( int i=0; i < vComPai.size(); i++ ) {
            Integer it = (Integer) vComPai.get(i);
            if( it.intValue() == ii ) {
                iIdx = i;
                break;
            }
        }
        if( iIdx >= 0 ) {
            comPaiRemove( iIdx );
        } else {
            System.out.println("debug: comPaiRemoveByPai() nC݂܂łBii=" + ii);
        }
    }
    //
    // 𔻒
    //
    public String checkYakuman() {
        Vector vTmp = new Vector();
        for( int i=0; i < vMyPai.size(); i++ ) {
            vTmp.add( vMyPai.get(i) );
        }
        Collections.sort( vTmp );
        String sOut = "";
        String s;
        s = checkChinroutou( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkRyuisou( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkTuisou( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkKokusimusou( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkSuAnko( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkDaiSanGen( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkSusiho( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        s = checkChurenboto( vTmp );
        if( s != null ) {
            sOut += " ";
            sOut += s;
        }
        return( sOut );
    }
    public String checkDaiSanGen( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        // 51,52,53                              // 
        // R邩
        boolean bIsHakuOK = false;
        for( int i=0; i < (iPai.length -2); i++ ) {
            if( iPai[i] == 51 && iPai[i+1] == 51 && iPai[i+2] == 51 ) {
                bIsHakuOK = true;
                break;
            }
        }
        if( bIsHakuOK ) {
        } else {
            return( null );
        }
        // R邩
        boolean bIsHatuOK = false;
        for( int i=0; i < (iPai.length -2); i++ ) {
            if( iPai[i] == 52 && iPai[i+1] == 52 && iPai[i+2] == 52 ) {
                bIsHatuOK = true;
                break;
            }
        }
        if( bIsHatuOK ) {
        } else {
            return( null );
        }
        // R邩
        boolean bIsChunOK = false;
        for( int i=0; i < (iPai.length -2); i++ ) {
            if( iPai[i] == 53 && iPai[i+1] == 53 && iPai[i+2] == 53 ) {
                bIsChunOK = true;
                break;
            }
        }
        if( bIsChunOK ) {
        } else {
            return( null );
        }
        return( "O" );
    }
    public String checkSuAnko( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        // ARA-1ɂ
        int iAnkoCnt = 0;
        for( int i=0; i < (iPai.length -2); i++ ) {
            if( iPai[i] > 0 && iPai[i+1] > 0 && iPai[i+2] > 0 ) {
                if( iPai[i] == iPai[i+1] && iPai[i] == iPai[i+2] ) {
                    iPai[i] = iPai[i+1] = iPai[i+2] = -1;
                    iAnkoCnt++;
                }
            }
        }
        if( iAnkoCnt >= 4 ) {
        } else {
            return( null );
        }
        // ܂check
        boolean bAtamaOK = false;
        for( int i=0; i < (iPai.length -1); i++ ) {
            if( iPai[i] > 0 && iPai[i+1] > 0 ) {
                if( iPai[i] == iPai[i+1] ) {
                    bAtamaOK = true;
                    break;
                }
            }
        }
        if( bAtamaOK ) {
            return( "lÍ" );
        } else {
            return( null );
        }
    }
    public String checkKokusimusou( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        // L̂ǂꂩ݂̂AȊO炾
        // 11,19,            // Y
        // 21,29,            // sY
        // 31,39,            // \EY
        // 41,42,43,44,                           // 쐼k
        // 51,52,53,                              // 
        for( int i=0; i < iPai.length; i++ ) {
            int ii = iPai[i];
            if( ii == 11 || ii == 19
             || ii == 21 || ii == 29
             || ii == 31 || ii == 39
             || ii == 41 || ii == 42 || ii == 43 || ii == 44
             || ii == 51 || ii == 52 || ii == 53 ) {
                continue;
            }
            return( null );
        }
        return( "mo" );
    }
    public String checkTuisou( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        for( int i=0; i < iPai.length; i++ ) {
            if( iPai[i] >= 41 ) {
                continue;
            }
            return( null );
        }
        return( "F" );
    }
    public String checkRyuisou( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        for( int i=0; i < iPai.length; i++ ) {
            int ii = iPai[i];
            if( ii >= 32 && ii <= 38 ) {
                continue;
            }
            if( ii == 52 ) {
                continue;
            }
            return( null );
        }
        return( "ΈF" );
    }
    public String checkChinroutou( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        // L̂ǂꂩ݂̂AȊO炾
        // 11,19,            // Y
        // 21,29,            // sY
        // 31,39,            // \EY
        for( int i=0; i < iPai.length; i++ ) {
            int ii = iPai[i];
            if( ii == 11 || ii == 19
             || ii == 21 || ii == 29
             || ii == 31 || ii == 39 ) {
                continue;
            }
            return( null );
        }
        return( "V" );
    }
    public String checkSusiho( Vector vPai ) {
//41,42,43,44,                           // 쐼k
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
        int iHigasiCnt = 0;
        int iMinamiCnt = 0;
        int iNisiCnt = 0;
        int iKitaCnt = 0;
        for( int i=0; i < iPai.length; i++ ) {  // ݂̐
            if( iPai[i] == 41 ) {
                iHigasiCnt++;
            }
            if( iPai[i] == 42 ) {
                iMinamiCnt++;
            }
            if( iPai[i] == 43 ) {
                iNisiCnt++;
            }
            if( iPai[i] == 44 ) {
                iKitaCnt++;
            }
        }
        if( iHigasiCnt == 3 
         && iMinamiCnt == 3
         && iNisiCnt == 3
         && iKitaCnt == 3 ) {
            return( "la(l)" );
        }
        if( iHigasiCnt == 2 ) {
            if( iMinamiCnt == 3 && iNisiCnt == 3 && iKitaCnt == 3 ) {
                return( "la(l)" );
            }
        }
        if( iMinamiCnt == 2 ) {
            if( iHigasiCnt == 3 && iNisiCnt == 3 && iKitaCnt == 3 ) {
                return( "la(l)" );
            }
        }
        if( iNisiCnt == 2 ) {
            if( iHigasiCnt == 3 && iMinamiCnt == 3 && iKitaCnt == 3 ) {
                return( "la(l)" );
            }
        }
        if( iKitaCnt == 2 ) {
            if( iHigasiCnt == 3 && iMinamiCnt == 3 && iNisiCnt == 3 ) {
                return( "la(l)" );
            }
        }
        return( null );
    }
    public String checkChurenboto( Vector vPai ) {
        int[] iPai = new int[ vPai.size() ];
        for( int i=0; i < vPai.size(); i++ ) {
            Integer it = (Integer) vPai.get(i);
            iPai[i] = it.intValue();
        }
//11,12,13,14,15,16,17,18,19,            // Y
//21,22,23,24,25,26,27,28,29,            // sY
//31,32,33,34,35,36,37,38,39,            // \EY
        boolean bAllMan = true;
        for( int i=0; i < iPai.length; i++ ) {
            int ii = iPai[i];
            if( ii >= 11 && ii <= 19 ) {
                continue;
            }
            bAllMan = false;
            break;
        }
        if( bAllMan ) {
            // PRȏ゠邩
            int i1Cnt = 0;
            for( int i=0; i < iPai.length; i++ ) {
                if( iPai[i] == 11 ) {
                    i1Cnt++;
                }
            }
            if( i1Cnt >= 3 ) {
            } else {
                return( null );
            }
            // 9Rȏ゠邩
            int i9Cnt = 0;
            for( int i=0; i < iPai.length; i++ ) {
                if( iPai[i] == 19 ) {
                    i9Cnt++;
                }
            }
            if( i9Cnt >= 3 ) {
            } else {
                return( null );
            }
            // Q邩
            if( isExist( iPai, 12 ) ) {
            } else {
                return( null );
            }
            // 3邩
            if( isExist( iPai, 13 ) ) {
            } else {
                return( null );
            }
            // 4邩
            if( isExist( iPai, 14 ) ) {
            } else {
                return( null );
            }
            // 5邩
            if( isExist( iPai, 15 ) ) {
            } else {
                return( null );
            }
            // 6邩
            if( isExist( iPai, 16 ) ) {
            } else {
                return( null );
            }
            // 7邩
            if( isExist( iPai, 17 ) ) {
            } else {
                return( null );
            }
            // 8邩
            if( isExist( iPai, 18 ) ) {
            } else {
                return( null );
            }
            return( "@" );
        }
        boolean bAllPin = true;
        for( int i=0; i < iPai.length; i++ ) {
            int ii = iPai[i];
            if( ii >= 21 && ii <= 29 ) {
                continue;
            }
            bAllPin = false;
            break;
        }
        if( bAllPin ) {
            // PRȏ゠邩
            int i1Cnt = 0;
            for( int i=0; i < iPai.length; i++ ) {
                if( iPai[i] == 21 ) {
                    i1Cnt++;
                }
            }
            if( i1Cnt >= 3 ) {
            } else {
                return( null );
            }
            // 9Rȏ゠邩
            int i9Cnt = 0;
            for( int i=0; i < iPai.length; i++ ) {
                if( iPai[i] == 29 ) {
                    i9Cnt++;
                }
            }
            if( i9Cnt >= 3 ) {
            } else {
                return( null );
            }
            // Q邩
            if( isExist( iPai, 22 ) ) {
            } else {
                return( null );
            }
            // 3邩
            if( isExist( iPai, 23 ) ) {
            } else {
                return( null );
            }
            // 4邩
            if( isExist( iPai, 24 ) ) {
            } else {
                return( null );
            }
            // 5邩
            if( isExist( iPai, 25 ) ) {
            } else {
                return( null );
            }
            // 6邩
            if( isExist( iPai, 26 ) ) {
            } else {
                return( null );
            }
            // 7邩
            if( isExist( iPai, 27 ) ) {
            } else {
                return( null );
            }
            // 8邩
            if( isExist( iPai, 28 ) ) {
            } else {
                return( null );
            }
            return( "@" );
        }
        boolean bAllSou = true;
        for( int i=0; i < iPai.length; i++ ) {
            int ii = iPai[i];
            if( ii >= 31 && ii <= 39 ) {
                continue;
            }
            bAllSou = false;
            break;
        }
        if( bAllSou ) {
            // PRȏ゠邩
            int i1Cnt = 0;
            for( int i=0; i < iPai.length; i++ ) {
                if( iPai[i] == 31 ) {
                    i1Cnt++;
                }
            }
            if( i1Cnt >= 3 ) {
            } else {
                return( null );
            }
            // 9Rȏ゠邩
            int i9Cnt = 0;
            for( int i=0; i < iPai.length; i++ ) {
                if( iPai[i] == 39 ) {
                    i9Cnt++;
                }
            }
            if( i9Cnt >= 3 ) {
            } else {
                return( null );
            }
            // Q邩
            if( isExist( iPai, 32 ) ) {
            } else {
                return( null );
            }
            // 3邩
            if( isExist( iPai, 33 ) ) {
            } else {
                return( null );
            }
            // 4邩
            if( isExist( iPai, 34 ) ) {
            } else {
                return( null );
            }
            // 5邩
            if( isExist( iPai, 35 ) ) {
            } else {
                return( null );
            }
            // 6邩
            if( isExist( iPai, 36 ) ) {
            } else {
                return( null );
            }
            // 7邩
            if( isExist( iPai, 37 ) ) {
            } else {
                return( null );
            }
            // 8邩
            if( isExist( iPai, 38 ) ) {
            } else {
                return( null );
            }
            return( "@" );
        }
        return( null );
    }
    //
    // COMvlpFnCpCAX^[g̎_ŁA߁A҂nC߂
    //
    // ́F vComPai, vComHaiPai
    // óF 
    //Vector vComAllHaiPai;        // bnlvlpFS̃nCpC
    //Vector vComAllHaiPaiNoDup;   // bnlvlpFS̏dȂnCpC
    //Vector vComAgariPai;         // bnlvlpFnC
    //Vector vComMachiPai;         // bnlvlpFnCƌ݂̃nC炵Ă̑҂ĂnC
    public boolean comInit() {
        // S̃nCpCɑS
        vComAllHaiPai = new Vector();
        for( int i=0; i < vComPai.size(); i++ ) {
            vComAllHaiPai.add( vComPai.get(i) );
        }
        for( int i=0; i < vComHaiPai.size(); i++ ) {
            vComAllHaiPai.add( vComHaiPai.get(i) );
        }
        Collections.sort( vComAllHaiPai );
        // SnC̏dȂnC
        vComAllHaiPaiNoDup = new Vector();
        Integer itPrev = new Integer(-1);
        for( int i=0; i < vComAllHaiPai.size(); i++ ) {
            Integer it = (Integer) vComAllHaiPai.get(i);
            if( it.intValue() == itPrev.intValue() ) {
                // Ȃ瑫Ȃ
            } else {
                vComAllHaiPaiNoDup.add( it );
                itPrev = new Integer( it.intValue() );
            }
        }
        Collections.sort( vComAllHaiPaiNoDup );
        // nC߂
        int[] iPai = new int[ vComAllHaiPaiNoDup.size() ];
        for( int i=0; i < vComAllHaiPaiNoDup.size(); i++ ) {
            Integer it = (Integer) vComAllHaiPaiNoDup.get(i);
            int ii = it.intValue();
            if( ii >= 11 && ii <= 39 ) {      // nC͂Ȃ
                iPai[i] = ii;
            }
        }
        Vector vvComAgariPaiTmp = new Vector();         // VectorVectorœ
        int iJunCnt = 0;
        for( int i=0; i < ( iPai.length -2); i++ ) {
            // q݂
            int ii1 = iPai[i];
            int ii2 = iPai[i+1];
            int ii3 = iPai[i+2];
            int ii1onedigit = ( ii1 % 10 );
            if( ii1onedigit >= 2 && ii1onedigit <= 6 ) {
                if( ii2 == (ii1 +1 ) ) {
                    if( ii3 == (ii1 +2 ) ) {
                        Vector v = new Vector();
                        v.add( new Integer( ii1 ));
                        v.add( new Integer( ii2 ));
                        v.add( new Integer( ii3 ));
                        iJunCnt++;
                        if( iJunCnt <= 4 ) {               // Sɐ
                            vvComAgariPaiTmp.add( v );
                        }
                        i += 2;
                    }
                }
            }
        }
        if( vvComAgariPaiTmp.size() >= 4 ) {
        } else {
System.out.println("debug: bnlvlŏq݂܂łAART܂");
System.out.println("debug: vComAllHaiPai=" + vComAllHaiPai );
System.out.println("debug: vComAllHaiPaiNoDup=" + vComAllHaiPaiNoDup );
            // ART
            return( false );
        }
        Vector vComAllHaiPai2 = removePai( vComAllHaiPai, vvComAgariPaiTmp ); // pC
        //
        // A^}݂
        int iAtama = -1;
        Integer itPrev2 = new Integer(-1);
        for( int i=0; i < vComAllHaiPai2.size(); i++ ) {
            Integer it = (Integer) vComAllHaiPai2.get(i);
            int ii = it.intValue();
            int iionedigit = (ii % 10);
            if( iionedigit >= 2 && iionedigit <= 8 ) {
                int iiPrev2 = itPrev2.intValue();
                if( ii ==  iiPrev2 ) {
                    iAtama = it.intValue();
                    break;
                }
            }
            itPrev2 = new Integer( it.intValue() );
        }
        if( iAtama > 0 ) {
        } else {
System.out.println("debug: bnlvlŁAA^}݂܂ł");
System.out.println("debug: vComAllHaiPai2=" + vComAllHaiPai2 );
            return( false );
        }
        Vector vAtama = new Vector();
        vAtama.add( new Integer( iAtama ) );
        vAtama.add( new Integer( iAtama ) );
        vvComAgariPaiTmp.add( vAtama );
System.out.println("debug: vvComAgariPaiTmp=" + vvComAgariPaiTmp );
        //
        // VectorVectorPȂVectorɂ
        vComAgariPai = new Vector();
        for( int i=0; i < vvComAgariPaiTmp.size(); i++ ) {
            Vector v = (Vector) vvComAgariPaiTmp.get(i);
            for( int j=0; j < v.size(); j++ ) {
                vComAgariPai.add( v.get(j) );
            }
        }
        Collections.sort( vComAgariPai );
System.out.println("debug: vComAgariPai=" + vComAgariPai );
        //
        // nCpCƂnCrAۑnCAXenCA҂nC߂
        Vector vComPaiTmp = new Vector();
        for( int i=0; i < vComPai.size(); i++ ) {  // vComPaiTmpփRs[
            vComPaiTmp.add( vComPai.get(i) );
        }
        vComMachiPaiForAgari = new Vector();
        //nCPoComPaiTmpĂ
        for( int i=0; i < vComAgariPai.size(); i++ ) {
            Integer it = (Integer) vComAgariPai.get(i);
            int ii = it.intValue();
            boolean bExist = isHaiExist( vComPaiTmp, ii );  // nCpCς݂ɂ邩
            if( bExist ) {
                // vComPaiTmp̂
                Vector vTmp = removePai( vComPaiTmp, it );
                vComPaiTmp = new Vector();
                for( int j=0; j < vTmp.size(); j++ ) {
                    vComPaiTmp.add( vTmp.get(j) );
                }
            } else {
                // ҂ɒǉ
                vComMachiPaiForAgari.add( it );
            }
        }
        // ̂ vComPaiTmp ̂ănC
        if( vComPaiTmp.isEmpty() ) {
            // ȂAK
System.out.println("debug: ߂AKnCƃnCpCvAAKł");
            return( false );
        }
        vComSutePaiForAgari = new Vector();
        for( int i=0; i < vComPaiTmp.size(); i++ ) {
            vComSutePaiForAgari.add( vComPaiTmp.get(i) );
        }
        // óF vComAgariPai   nC
        // óF vComMachiPai   ҂nC
        // óF vComSutePai    ̂ănC

        return( true );
    }
    public Vector removePai( Vector vAll, Vector vvRemove ) {  // pCĕԂAQԖڂVectorVector
        // VectorVectorPȂVector֒
        Vector vRemove = new Vector();
        for( int i=0; i < vvRemove.size(); i++ ) {
            Vector v = (Vector) vvRemove.get(i);
            for( int j=0; j < v.size(); j++ ) {
                vRemove.add( v.get(j) );
            }
        }
        // PP̃pC郋[v
        Vector vOut = new Vector();
        for( int i=0; i < vRemove.size(); i++ ) {
            Integer it = (Integer) vRemove.get(i);
            vOut = removePai( vAll, it );
            vAll = new Vector();
            for( int j=0; j < vOut.size(); j++ ) {
                vAll.add( vOut.get(j) );
            }
        }
        return( vOut );
    }
    public Vector removePai( Vector vAll, Integer itRemove ) {  // pCĕԂAQԖڂInteger
        Vector vOut = new Vector();
        int iRemove = itRemove.intValue();
        for( int i=0; i < vAll.size(); i++ ) {
            Integer it = (Integer) vAll.get(i);
            if( it.intValue() == iRemove ) {
                // Ȃ
                iRemove = -1;   // `FbN͂Pɂ
            } else {
                vOut.add( it );
            }
        }
        return( vOut );
    }
    boolean isHaiExist( Vector v, int ii ) {  // nC邩
        for( int i=0; i < v.size(); i++ ) {
            Integer it = (Integer) v.get(i);
            if( it.intValue() == ii ) {
                return( true );
            }
        }
        return( false );
    }
    //
    // Tu[`
    //
    public boolean isExist( int[] iPai, int iCheck ) {   // z̒ɐl邩ǂ
        for( int i=0; i < iPai.length; i++ ) {
            if( iPai[i] == iCheck ) {
                return( true );
            }
        }
        return( false );
    }
    // iPai OȂEnC
    public JButton createPaiButton( int iPai, boolean bIsBigButton ) {
        String sSmallButton = "";
        if( bIsBigButton ) {
        } else {
            sSmallButton = "s-";
        }
        String sPai = "";
        sPai += sSmallButton;
        if( iPai == 0 ) sPai += "ura";
        if( iPai >= 11 && iPai <= 19 ) {    // }Y
            int i = ( iPai % 10 );
            sPai += "man";
            sPai += Integer.toString( i );
        }
        if( iPai >= 21 && iPai <= 29 ) {    // sY
            int i = ( iPai % 10 );
            sPai += "pin";
            sPai += Integer.toString( i );
        }
        if( iPai >= 31 && iPai <= 39 ) {    // \EY
            int i = ( iPai % 10 );
            sPai += "sou";
            sPai += Integer.toString( i );
        }
        if( iPai == 41 ) sPai += "ji-ton";
        if( iPai == 42 ) sPai += "ji-nan";
        if( iPai == 43 ) sPai += "ji-sha";
        if( iPai == 44 ) sPai += "ji-pei";
        if( iPai == 51 ) sPai += "ji-haku";
        if( iPai == 52 ) sPai += "ji-hatsu";
        if( iPai == 53 ) sPai += "ji-chun";
        ImageIcon imgButtonIcon = createImageIcon(sPai + ".gif");
        JButton btn = new JButton( "", imgButtonIcon );
        return( btn );
    }
    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = mahjong.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Couldn't find file: " + path);
            System.exit(1);
        }
        return( null );
    }
    
    
    public static void main(String[] args) {
        //Schedule a job for the event dispatch thread:
        //creating and showing this application's GUI.
        //javax.swing.SwingUtilities.invokeLater(new Runnable() {
        //    public void run() {
        //        createAndShowGUI();
        //    }
        //});
        //Create and set up the window.
        mahjong frame = new mahjong();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.ikasamaHaipai();
        //Set up the content pane.
        frame.addComponentsToPane(frame.getContentPane());
        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }
}
